#ifndef __X10_UTIL_OPTIONSPARSER_H
#define __X10_UTIL_OPTIONSPARSER_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
namespace x10 { namespace util { 
template<class TPMGL(K), class TPMGL(V)> class HashMap;
} } 
namespace x10 { namespace lang { 
class String;
} } 
namespace x10 { namespace lang { 
class Boolean;
} } 
namespace x10 { namespace array { 
template<class TPMGL(T)> class Array;
} } 
namespace x10 { namespace util { 
class Option;
} } 
namespace x10 { namespace util { 
template<class TPMGL(T)> class GrowableIndexedMemoryChunk;
} } 
namespace x10 { namespace lang { 
class Int;
} } 
namespace x10 { namespace lang { 
class Any;
} } 
namespace x10 { namespace array { 
class Region;
} } 
namespace x10 { namespace lang { 
class Char;
} } 
namespace x10 { namespace lang { 
template<class TPMGL(T)> class Iterator;
} } 
namespace x10 { namespace lang { 
template<class TPMGL(T)> class Iterable;
} } 
namespace x10 { namespace util { 
class OptionsParser__Err;
} } 
namespace x10 { namespace lang { 
class Math;
} } 
namespace x10 { namespace lang { 
class UByte;
} } 
namespace x10 { namespace lang { 
class NumberFormatException;
} } 
namespace x10 { namespace lang { 
class Byte;
} } 
namespace x10 { namespace lang { 
class UShort;
} } 
namespace x10 { namespace lang { 
class Short;
} } 
namespace x10 { namespace lang { 
class UInt;
} } 
namespace x10 { namespace lang { 
class ULong;
} } 
namespace x10 { namespace lang { 
class Long;
} } 
namespace x10 { namespace lang { 
class Double;
} } 
namespace x10 { namespace lang { 
class Float;
} } 
namespace x10 { namespace util { 

class OptionsParser : public x10::lang::Object   {
    public:
    RTT_H_DECLS_CLASS
    
    x10aux::ref<x10::util::HashMap<x10aux::ref<x10::lang::String>, x10aux::ref<x10::lang::String> > >
      FMGL(map);
    
    x10aux::ref<x10::util::HashMap<x10aux::ref<x10::lang::String>, x10_boolean> >
      FMGL(set);
    
    x10aux::ref<x10::array::Array<x10::util::Option> > FMGL(flags);
    
    x10aux::ref<x10::array::Array<x10::util::Option> > FMGL(specs);
    
    x10aux::ref<x10::util::GrowableIndexedMemoryChunk<x10aux::ref<x10::lang::String> > >
      FMGL(filteredArgs);
    
    void _constructor(x10aux::ref<x10::array::Array<x10aux::ref<x10::lang::String> > > args,
                      x10aux::ref<x10::array::Array<x10::util::Option> > flags,
                      x10aux::ref<x10::array::Array<x10::util::Option> > specs);
    
    static x10aux::ref<x10::util::OptionsParser> _make(x10aux::ref<x10::array::Array<x10aux::ref<x10::lang::String> > > args,
                                                       x10aux::ref<x10::array::Array<x10::util::Option> > flags,
                                                       x10aux::ref<x10::array::Array<x10::util::Option> > specs);
    
    virtual x10aux::ref<x10::array::Array<x10aux::ref<x10::lang::String> > >
      filteredArgs();
    static x10aux::ref<x10::lang::String> padding(x10_int p);
    virtual x10aux::ref<x10::lang::String> usage();
    virtual x10_boolean __apply(x10aux::ref<x10::lang::String> key);
    virtual x10aux::ref<x10::lang::String> __apply(x10aux::ref<x10::lang::String> key,
                                                   x10aux::ref<x10::lang::String> d);
    virtual x10_ubyte __apply(x10aux::ref<x10::lang::String> key,
                              x10_ubyte d);
    virtual x10_byte __apply(x10aux::ref<x10::lang::String> key,
                             x10_byte d);
    virtual x10_ushort __apply(x10aux::ref<x10::lang::String> key,
                               x10_ushort d);
    virtual x10_short __apply(x10aux::ref<x10::lang::String> key,
                              x10_short d);
    virtual x10_uint __apply(x10aux::ref<x10::lang::String> key,
                             x10_uint d);
    virtual x10_int __apply(x10aux::ref<x10::lang::String> key,
                            x10_int d);
    virtual x10_ulong __apply(x10aux::ref<x10::lang::String> key,
                              x10_ulong d);
    virtual x10_long __apply(x10aux::ref<x10::lang::String> key,
                             x10_long d);
    virtual x10_double __apply(x10aux::ref<x10::lang::String> key,
                               x10_double d);
    virtual x10_float __apply(x10aux::ref<x10::lang::String> key,
                              x10_float d);
    virtual x10aux::ref<x10::util::OptionsParser> x10__util__OptionsParser____x10__util__OptionsParser__this(
      );
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};

} } 
#endif // X10_UTIL_OPTIONSPARSER_H

namespace x10 { namespace util { 
class OptionsParser;
} } 

#ifndef X10_UTIL_OPTIONSPARSER_H_NODEPS
#define X10_UTIL_OPTIONSPARSER_H_NODEPS
#ifndef X10_UTIL_OPTIONSPARSER_H_GENERICS
#define X10_UTIL_OPTIONSPARSER_H_GENERICS
#endif // X10_UTIL_OPTIONSPARSER_H_GENERICS
#endif // __X10_UTIL_OPTIONSPARSER_H_NODEPS
